/// <reference types="node" />
import { Chunk } from 'blockmap';
import { Writable } from 'readable-stream';
import { SourceDestination } from './source-destination/source-destination';
import { SparseWriteStream } from './sparse-write-stream';
export declare class DestinationSparseWriteStream extends Writable implements SparseWriteStream {
    private destination;
    firstBytesToKeep: number;
    private maxRetries;
    position: number;
    bytesWritten: number;
    private _firstChunks;
    constructor(destination: SourceDestination, firstBytesToKeep?: number, maxRetries?: number);
    private writeChunk;
    private __write;
    _write(chunk: Chunk, enc: string, callback: (error: Error | undefined) => void): void;
    __final(): Promise<void>;
    /**
     * @summary Write buffered data before a stream ends, called by stream internals
     */
    _final(callback: (error?: Error | void) => void): void;
}
export declare const ProgressDestinationSparseWriteStream: {
    new (...args: any[]): {
        _attributeValue: number;
        _attributeDelta: number;
        addListener(event: string | symbol, listener: Function): any;
        on(event: string | symbol, listener: Function): any;
        once(event: string | symbol, listener: Function): any;
        prependListener(event: string | symbol, listener: Function): any;
        prependOnceListener(event: string | symbol, listener: Function): any;
        removeListener(event: string | symbol, listener: Function): any;
        removeAllListeners(event?: string | symbol | undefined): any;
        setMaxListeners(n: number): any;
        getMaxListeners(): number;
        listeners(event: string | symbol): Function[];
        emit(event: string | symbol, ...args: any[]): boolean;
        eventNames(): (string | symbol)[];
        listenerCount(type: string | symbol): number;
    };
} & typeof DestinationSparseWriteStream;
