/// <reference types="node" />
export declare class NotCapable extends Error {
}
export declare class VerificationError extends Error {
    code: string;
}
export declare class ChecksumVerificationError extends VerificationError {
    checksum: string;
    expectedChecksum: string;
    constructor(message: string, checksum: string, expectedChecksum: string);
}
/**
 * @summary Determine whether an error is considered a
 * transient occurrence, and the operation should be retried
 * Errors considered potentially temporary are:
 *   - Mac OS: ENXIO, EBUSY
 *   - Windows: ENOENT, UNKNOWN
 *   - Linux: EIO, EBUSY
 */
export declare function isTransientError(error: NodeJS.ErrnoException): boolean;
