/// <reference types="node" />
import { ReadResult, WriteResult } from 'file-disk';
import * as fs from 'fs';
export declare function close(fd: number): Promise<void>;
export declare function fstat(fd: number): Promise<fs.Stats>;
export declare function fsync(fd: number): Promise<void>;
export declare function open(path: string | Buffer, flags: string | number, mode?: number): Promise<number>;
export declare function read(fd: number, buffer: Buffer, offset: number, length: number, position: number): Promise<ReadResult>;
export declare function readFile(path: string, options?: {
    encoding: string | null;
    flag: string;
} | undefined): Promise<string | Buffer>;
export declare function stat(path: string | Buffer): Promise<fs.Stats>;
export declare function writeFile(path: string, data: string | Buffer, options?: {
    encoding: string;
    mode: number;
    flag: string;
}): Promise<void>;
export declare function unlink(path: string | Buffer): Promise<void>;
export declare function write(fd: number, buffer: Buffer, offset: number, length: number, position: number): Promise<WriteResult>;
