/// <reference types="node" />
import { Drive as DrivelistDrive } from 'drivelist';
import { ReadResult, WriteResult } from 'file-disk';
import { AdapterSourceDestination } from '../scanner/adapters/adapter';
import { BlockWriteStream } from '../block-write-stream';
import { DestinationSparseWriteStream } from '../destination-sparse-write-stream';
import { File } from './file';
import { Metadata } from './metadata';
export declare class BlockDevice extends File implements AdapterSourceDestination {
    private drive;
    private unmountOnSuccess;
    emitsProgress: boolean;
    constructor(drive: DrivelistDrive, unmountOnSuccess?: boolean);
    readonly isSystem: boolean;
    readonly raw: string;
    readonly device: string;
    readonly devicePath: string | null;
    readonly description: string;
    readonly mountpoints: {
        path: string;
    }[];
    readonly size: number | null;
    _getMetadata(): Promise<Metadata>;
    canWrite(): Promise<boolean>;
    canCreateWriteStream(): Promise<boolean>;
    canCreateSparseWriteStream(): Promise<boolean>;
    createWriteStream(): Promise<BlockWriteStream>;
    createSparseWriteStream(): Promise<DestinationSparseWriteStream>;
    protected _open(): Promise<void>;
    protected _close(): Promise<void>;
    private offsetIsAligned;
    private alignOffsetBefore;
    private alignOffsetAfter;
    private alignedRead;
    read(buffer: Buffer, bufferOffset: number, length: number, sourceOffset: number): Promise<ReadResult>;
    private alignedWrite;
    write(buffer: Buffer, bufferOffset: number, length: number, fileOffset: number): Promise<WriteResult>;
}
