/// <reference types="node" />
import { FilterStream } from 'blockmap';
import { Metadata } from './metadata';
import { SourceDestination } from './source-destination';
import { SourceSource } from './source-source';
export declare class DmgSource extends SourceSource {
    static requiresRandomReadableSource: boolean;
    static readonly mimetype = "application/x-apple-diskimage";
    private image;
    constructor(source: SourceDestination);
    canCreateReadStream(): Promise<boolean>;
    canCreateSparseReadStream(): Promise<boolean>;
    createReadStream(emitProgress?: boolean, start?: number, end?: number): Promise<NodeJS.ReadableStream>;
    createSparseReadStream(generateChecksums: boolean): Promise<FilterStream>;
    getMappedBlocksSize: () => number;
    _getMetadata(): Promise<Metadata>;
    protected _open(): Promise<void>;
    protected _close(): Promise<void>;
}
