/// <reference types="node" />
import { ReadResult, WriteResult } from 'file-disk';
import { Metadata } from './metadata';
import { SourceDestination } from './source-destination';
import { DestinationSparseWriteStream } from '../destination-sparse-write-stream';
export declare const ProgressWriteStream: any;
export declare class File extends SourceDestination {
    private path;
    private flags;
    protected fd: number;
    blockSize: number;
    constructor(path: string, flags: File.OpenFlags);
    private _canRead;
    private _canWrite;
    canRead(): Promise<boolean>;
    canWrite(): Promise<boolean>;
    canCreateReadStream(): Promise<boolean>;
    canCreateWriteStream(): Promise<boolean>;
    canCreateSparseWriteStream(): Promise<boolean>;
    _getMetadata(): Promise<Metadata>;
    read(buffer: Buffer, bufferOffset: number, length: number, sourceOffset: number): Promise<ReadResult>;
    write(buffer: Buffer, bufferOffset: number, length: number, fileOffset: number): Promise<WriteResult>;
    createReadStream(emitProgress?: boolean, start?: number, end?: number): Promise<NodeJS.ReadableStream>;
    createWriteStream(): Promise<NodeJS.WritableStream>;
    createSparseWriteStream(): Promise<DestinationSparseWriteStream>;
    protected _open(): Promise<void>;
    protected _close(): Promise<void>;
}
export declare namespace File {
    enum OpenFlags {
        Read,
        ReadWrite,
        WriteDevice
    }
}
