/// <reference types="node" />
import { ReadResult } from 'file-disk';
import { Metadata } from './metadata';
import { SourceDestination } from './source-destination';
export declare class Http extends SourceDestination {
    private url;
    private size;
    private acceptsRange;
    private ready;
    private error;
    constructor(url: string);
    private getInfo;
    canRead(): Promise<boolean>;
    canCreateReadStream(): Promise<boolean>;
    _getMetadata(): Promise<Metadata>;
    private getRange;
    read(buffer: Buffer, bufferOffset: number, length: number, sourceOffset: number): Promise<ReadResult>;
    createReadStream(emitProgress?: boolean, start?: number, end?: number): Promise<NodeJS.ReadableStream>;
}
