/// <reference types="node" />
import BlockMap = require('blockmap');
import { Metadata } from './metadata';
import { SourceDestination } from './source-destination';
import { SourceSource } from './source-source';
export declare class StreamZipSource extends SourceSource {
    private entry?;
    canCreateReadStream(): Promise<boolean>;
    private getEntry;
    createReadStream(emitProgress?: boolean, start?: number, end?: number): Promise<NodeJS.ReadableStream>;
    _getMetadata(): Promise<Metadata>;
}
export declare class RandomAccessZipSource extends SourceSource {
    private static manifestFields;
    private zip;
    private ready;
    private entries;
    constructor(source: SourceDestination);
    init(): Promise<void>;
    canCreateReadStream(): Promise<boolean>;
    canCreateSparseReadStream(): Promise<boolean>;
    private getEntries;
    private getImageEntry;
    _open(): Promise<void>;
    private getEntryByName;
    private getStream;
    private getString;
    private getJson;
    createReadStream(emitProgress?: boolean, start?: number, end?: number): Promise<NodeJS.ReadableStream>;
    createSparseReadStream(generateChecksums?: boolean): Promise<BlockMap.FilterStream>;
    _getMetadata(): Promise<Metadata>;
}
export declare class ZipSource extends SourceSource {
    private preferStreamSource;
    static readonly mimetype = "application/zip";
    private implementation;
    constructor(source: SourceDestination, preferStreamSource?: boolean);
    private prepare;
    canCreateReadStream(): Promise<boolean>;
    open(): Promise<void>;
    canCreateSparseReadStream(): Promise<boolean>;
    createReadStream(emitProgress?: boolean, start?: number, end?: number): Promise<NodeJS.ReadableStream>;
    createSparseReadStream(generateChecksums?: boolean): Promise<BlockMap.FilterStream | BlockMap.ReadStream>;
    _getMetadata(): Promise<Metadata>;
}
